/**
 * LogicalOperation.java
 *
 * File generated from the XValidator4::LogicalOperation uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.xvalidation.core.model;

import junit.framework.Assert;
import junit.framework.AssertionFailedError;
import net.ihe.gazelle.xvalidation.core.exception.GazelleXValidationException;
import net.ihe.gazelle.xvalidation.core.report.Notification;
import net.ihe.gazelle.xvalidation.core.report.Report;
import org.hibernate.annotations.CollectionId;
import org.hibernate.annotations.Fetch;
import org.hibernate.annotations.FetchMode;
import org.hibernate.annotations.GenericGenerator;
import org.hibernate.annotations.Type;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.w3c.dom.Node;

import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.DiscriminatorValue;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.OrderBy;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
// End of user code

/**
 * Description of the class LogicalOperation.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "LogicalOperation", propOrder = { "expressionSet", "logicalOperator" })
@XmlRootElement(name = "LogicalOperation")
@Entity
@DiscriminatorValue("logicalOperation")
public class LogicalOperation extends AbstractExpression {

	private static Logger log = LoggerFactory.getLogger(LogicalOperation.class);

	/**
	 *
	 */
	private static final long serialVersionUID = 1L;
	private static final int MIN_EXPRESSION_SET_SIZE = 2;

	@XmlElementRefs({ @XmlElementRef(name = "Not", type = Not.class),
		@XmlElementRef(name = "InValueSet", type = InValueSet.class),
		@XmlElementRef(name = "Present", type = Present.class),
		@XmlElementRef(name = "LogicalOperation", type = LogicalOperation.class),
		@XmlElementRef(name = "BasicOperation", type = BasicOperation.class),
        @XmlElementRef(name = "MathComparison", type = MathComparison.class),
		@XmlElementRef(name = "ForEach", type = ForEach.class), @XmlElementRef(name = "True", type = True.class) })
	@OneToMany(fetch = FetchType.EAGER, cascade = { CascadeType.ALL })
	@JoinTable(name = "xval_logical_operation_expression_set")
	@GenericGenerator(name = "xval_expression_set_id_generator", strategy = "increment")
	@CollectionId(columns = @Column(name = "xval_expression_set_id"), type = @Type(type = "int"), generator = "xval_expression_set_id_generator")
	@Fetch(value = FetchMode.SELECT)
	@OrderBy // we need to make sure the expressionSet is using the same order as the user entered it, in particular for OR
	// clauses since the validator shall stop as soon as a member is evaluated to true
	private List<AbstractExpression> expressionSet;

	@XmlAttribute(name = "logicalOperator", required = true)
	@Column(name = "logical_operator")
	private LogicalOperatorType logicalOperator;

	public LogicalOperation() {
		super();
	}
	
	public LogicalOperation(LogicalOperation exp){
		super();
		this.logicalOperator = exp.getLogicalOperator();
		for (AbstractExpression member : exp.getExpressionSet()){
			addExpressionSet(member.createCopy());
		}
	}

	public LogicalOperation(LogicalOperatorType operator) {
		super();
		this.logicalOperator = operator;
	}

	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	@Transient
	private org.w3c.dom.Node xmlNodePresentation;

	/**
	 * Return expressionSet.
	 *
	 * @return expressionSet
	 */
	public List<AbstractExpression> getExpressionSet() {
		if (expressionSet == null) {
			expressionSet = new ArrayList<AbstractExpression>();
		}
		return expressionSet;
	}

	/**
	 * Set a value to attribute expressionSet.
	 *
	 * @param expressionSet
	 *            .
	 */
	public void setExpressionSet(List<AbstractExpression> expressionSet) {
		this.expressionSet = expressionSet;
	}

	/**
	 * Add a expressionSet to the expressionSet collection.
	 *
	 * @param expressionSetElement
	 *            Element to add.
	 */
	public void addExpressionSet(AbstractExpression expressionSetElement) {
		this.getExpressionSet().add(expressionSetElement);
	}

	/**
	 * Remove a expressionSet to the expressionSet collection.
	 *
	 * @param expressionSetElement
	 *            Element to remove
	 */
	public void removeExpressionSet(AbstractExpression expressionSetElement) {
		this.getExpressionSet().remove(expressionSetElement);
	}

	/**
	 * Return logicalOperator.
	 *
	 * @return logicalOperator
	 */
	public LogicalOperatorType getLogicalOperator() {
		return logicalOperator;
	}

	/**
	 * Set a value to attribute logicalOperator.
	 *
	 * @param logicalOperator
	 *            .
	 */
	public void setLogicalOperator(LogicalOperatorType logicalOperator) {
		this.logicalOperator = logicalOperator;
	}

	@Override
	public Node getXmlNodePresentation() {
		if (xmlNodePresentation == null) {
			xmlNodePresentation = ObjectFactory.getXmlNodePresentation("", "LogicalOperation", this);
		}
		return xmlNodePresentation;
	}

	@Override
	public void setXmlNodePresentation(Node xmlNodePresentation) {
		this.xmlNodePresentation = xmlNodePresentation;
	}

	@Override
	public Notification evaluate(Map<String, Node> documents, ValidatorConfiguration configuration, Level level) {

		if ((expressionSet != null) && (expressionSet.size() > 1)) {
			switch (this.logicalOperator) {
			case AND:
				return evaluateAnd(documents, configuration, level);
			case OR:
				return evaluateOr(documents, configuration, level);
			case XOR:
				return evaluateXor(documents, configuration, level);
			default:
				return abort(this.logicalOperator.getValue() + " is not a supported operation", null, this.logicalOperator.getValue() + " is not a supported operation");
			}
		} else {
			return abort("Expression is incorrect, " + this.logicalOperator.value() + " expects at least two members", null, "Expression is incorrect, " + this.logicalOperator.value() + " expects at least two members");
		}
	}

	private Notification evaluateXor(Map<String, Node> documents, ValidatorConfiguration configuration, Level level) {

		StringBuilder xpathReport = new StringBuilder();
		Notification notification = expressionSet.get(0).evaluate(documents, configuration, level);
		xpathReport.append(notification.getXpathReport());
		xpathReport.append("XOR ");
		boolean result = notification instanceof Report;

		for (int index = 1; index < expressionSet.size(); index++) {
			notification = expressionSet.get(index).evaluate(documents, configuration, level);
			xpathReport.append(notification.getXpathReport());
			if (index != expressionSet.size() -1){
				xpathReport.append("XOR ");
			}
			result = result ^ (notification instanceof Report);
		}

		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport(xpathReport.toString());
		return resultNotification;
	}

	private Notification evaluateOr(Map<String, Node> documents, ValidatorConfiguration configuration, Level level) {
		StringBuilder xpathReport = new StringBuilder();
		Notification notification = expressionSet.get(0).evaluate(documents, configuration, level);
		xpathReport.append(notification.getXpathReport());
		xpathReport.append("OR ");
		boolean result = notification instanceof Report;

		for (int index = 1; index < expressionSet.size(); index++) {
			notification = expressionSet.get(index).evaluate(documents, configuration, level);
			xpathReport.append(notification.getXpathReport());
			if (index != expressionSet.size() -1){
				xpathReport.append("OR ");
			}
			result = result || (notification instanceof Report);
		}

		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport(xpathReport.toString());
		return resultNotification;
	}

	private Notification evaluateAnd(Map<String, Node> documents, ValidatorConfiguration configuration, Level level){
		StringBuilder xpathReport = new StringBuilder();
		Notification notification = expressionSet.get(0).evaluate(documents, configuration, level);
		xpathReport.append(notification.getXpathReport());
		xpathReport.append("AND ");
		boolean result = notification instanceof Report;

		for (int index = 1; index < expressionSet.size(); index++) {
			notification = expressionSet.get(index).evaluate(documents, configuration, level);
			xpathReport.append(notification.getXpathReport());
			if (index != expressionSet.size()-1){
				xpathReport.append("AND ");
			}
			result = result && (notification instanceof Report);
		}

		Notification resultNotification;
		if (!result){
			resultNotification = newNotificationForLevel(level);
		} else {
			resultNotification = newNotificationForLevel(null);
		}
		resultNotification.setXpathReport(xpathReport.toString());
		return resultNotification;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		int index;
		for (index = 0; index < (this.expressionSet.size() - 1); index++) {
			builder.append('(');
			builder.append(this.expressionSet.get(index).toString());
			builder.append(')');
			builder.append("<br/>");
			builder.append(this.logicalOperator.getFriendlyName());
			builder.append("<br/>");
		}
		builder.append('(');
		builder.append(this.expressionSet.get(index).toString());
		builder.append(')');
		return builder.toString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = (prime * result) + ((logicalOperator == null) ? 0 : logicalOperator.hashCode());
		result = (prime * result) + ((expressionSet == null) ? 0 : expressionSet.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (!super.equals(obj)) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		LogicalOperation other = (LogicalOperation) obj;
		if (logicalOperator != other.logicalOperator) {
			return false;
		}
		if (expressionSet == null) {
			if (other.expressionSet != null) {
				return false;
			}
		} else if (!expressionSet.equals(other.expressionSet)) {
			return false;
		}
		return true;
	}

	@Override
	public String getEditLink() {
		return "/xvalidation/expressions/logicalOperation.xhtml";
	}

	@Override
	public void testCorrectness() throws AssertionFailedError {
		Assert.assertNotNull("[Expression #" + getFakeId() + "] No logical operator selected", logicalOperator);
		Assert.assertNotNull("[Expression #" + getFakeId() + "] No expression selected", expressionSet);
		Assert.assertTrue("[Expression #" + getFakeId() + "] At least two members are required", expressionSet.size() >= MIN_EXPRESSION_SET_SIZE);
		for (AbstractExpression ex : expressionSet){
			ex.testCorrectness();
		}
	}

	@Override
	public ArrayList<String> appliesTo() throws AssertionFailedError {
		ArrayList<String> keywords = new ArrayList<String>();
		testCorrectness();
		for (AbstractExpression ex : expressionSet){
			List<String> keywordsFromExpressionSet = ex.appliesTo();
			for (String keyword : keywordsFromExpressionSet){
				if (!keywords.contains(keyword)){
					keywords.add(keyword);
				}
			}
		}
		return keywords;
	}

	@Override
	public AbstractExpression createCopy() {
		return new LogicalOperation(this);
	}
}